//*****************************************************
unsigned char line[8];
unsigned char line_v[8];
unsigned char temp;
unsigned char hh,mm,ss;

bit minuta_plus;
unsigned char previous_minuta, next_minuta, old_mm;
unsigned char run= 5;



bit old_key, key;// .
bit push_key, long_press;
unsigned char push_counter;

// .
flash unsigned int zader[10]= {10,900,820,700,640,590,540,500,470,450};
unsigned int counter_majat= 500;
bit naprawlenie= 1;
bit storona;
unsigned char nomer= 1;
unsigned char majatnik= 20;
bit start_majat= 1;
bit old_sqw, sqw;



#include <90s8535.h>
#include <delay.h>
#include <bcd.h>

#asm
   .equ __i2c_port=0x18 ;PORTB
   .equ __sda_bit=1
   .equ __scl_bit=2
#endasm
#include <i2c.h>
#include <ds1307.h>
#include "timer0.c"


void main(void)
{
delay_ms(1000);//  .

#include "init.c"//.

//  .
hh= rtc_read(0);//  (ClockHalt)  7- .
if(hh & 0x80)//  
	{
	rtc_init(0,1,0);// Control Register.
	rtc_write(0,hh & 0x7f);//  .
	hh= rtc_read(2);
	rtc_write(2,hh & 0xBF);//24-  .
	}

// .
while (1)
	{
	rtc_get_time(&hh, &mm, &ss);// .


	if(old_mm!= mm && !long_press)//   .
		{
		minuta_plus= 1;//  .
		previous_minuta= 60;//  60-
		next_minuta= 59;//.
		}
	old_mm= mm;



	// .
	if(push_key || long_press)//   .
		{
		push_key= 0;
		ss= 0;
		if(++mm>=60)
			{
			mm= 0;
			if(++hh>=24)
				{
				hh= 0;
				}
			}
		rtc_set_time(hh & 0x3F, mm & 0x7F, ss & 0x7F);//  DS1307

		if(long_press) delay_ms(5);//   .
		}

	// .
	line[0]= line[1]= line[2]= line[3]= line[4]= line[5]= line[6]= line[7]= 0;
	for(temp= 0; temp<= mm; temp++)//  .
		{
#asm
	SEC
	LDS	R30,_line+7
	ROL	R30
	STS	_line+7,R30

	LDS	R30,_line+6
	ROL	R30
	BREQ	lab1
	STS	_line+6,R30
	LDS	R30,_line+5
	ROL	R30
	BREQ	lab1
	STS	_line+5,R30
	LDS	R30,_line+4
	ROL	R30
	BREQ	lab1
	STS	_line+4,R30
	LDS	R30,_line+3
	ROL	R30
	BREQ	lab1
	STS	_line+3,R30
	LDS	R30,_line+2
	ROL	R30
	BREQ	lab1
	STS	_line+2,R30
	LDS	R30,_line+1
	ROL	R30
	BREQ	lab1
	STS	_line+1,R30
	LDS	R30,_line
	ROL	R30
	STS	_line,R30
lab1:
#endasm
		}

	//   59- .
	if(mm== 59 && ss)
		{
		for(temp= 0; temp< ss; temp++)
			{
			line[7- temp/8]&= 0xFF ^ (1<<(temp - temp/8*8));// .
			}
		}

	if(!long_press && PINB.4)//      
		{
		// .
		line[7 - majatnik/8]^= 1<< (majatnik - majatnik/8*8);
#pragma warn-
		line[7 - (majatnik+1)/8]^= 1<< ((majatnik+1) - (majatnik+1)/8*8);
#pragma warn+
		}

	// .
	#include "mm_plus.c"

	// .
	temp= hh - hh/12*12;//temp= 0...11
	temp*= 5;//temp= 0, 5, 10,..., 55
	hh= 1<< (temp - temp/8*8);
	if(!long_press)
		{
		if(!PINB.3)
			{
			line[7-temp/8]= line[7-temp/8] | hh;
			}
		else
			{
			hh^= 0xFF;
			line[7-temp/8]= line[7-temp/8] & hh;
			}
		}
	else line[7-temp/8]^= hh;


	//  ""
#asm("cli")
	line_v[0]= line[0];
	line_v[1]= line[1];
	line_v[2]= line[2];
	line_v[3]= line[3];
	line_v[4]= line[4];
	line_v[5]= line[5];
	line_v[6]= line[6];
	line_v[7]= line[7];
#asm("sei")

	//   .
	delay_ms(15);
	};
}
